/*
cd ~/C/PSgraf3/examples
g++ -o _coordinates coordinates.cpp -lPSgraf3
_coordinates
*/
/*
coordinates: creates figure 1 of the PSgraf manual
*/

#include <PSgraf3.h>

int main()
{
  gPaper("fig/coordinates");
    dXAxis(0,0,65,1); dYAxis(0,0,40,1);
    movea('P',35,1); dText("Paper coordinates");

    sXWorldCoord(0,5600,20,58); sYWorldCoord(0,0.34,15,40);
    sXIntervals(2000,500,0,0);  sYIntervals(0.1,0.05,0,1);

    sStroke(0.3); sThickness(0.5); dXAxis(0,0,5600,1);

    sColorSpace("RGB");
    sStroke(1,0,0); sThickness(0.2); dYAxis(0,0,0.34,1);

    movea('W',1500,0.01); dText("World coordinates");
  endPS();
  
  return 0;
}
