#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dLine: draw line from x0 to x1 in coordinate system CS [P,W]

HISTORY:
  v3.0.0									031115kr
--------------------------------------------------------------------------------------*/
void dLine(char CS,struct dvec x0,struct dvec x1)
{
  if (x0.dim!=x1.dim) PSerror("dLine","different dimensions");

  fprintf(PSout,"%%--dLine (%c%i)\n",CS,x0.dim);

  fprintf(PSout,"newpath\n");
  movea(CS,x0); linea(CS,x1);
  fprintf(PSout,"stroke\n");

  return;
}
/*--------------------------------------------------------------------------------------
dLine: draw line from x0 to x1 in coordinate system CS [P,W]

HISTORY:
  v3.0.0									031115kr
--------------------------------------------------------------------------------------*/
void dLine(char CS,double x0,double y0,double z0,double x1,double y1,double z1)
{
  struct dvec x,y;

  x.dim=y.dim=3;
  x.x=x0; x.y=y0; x.z=z0; y.x=x1; y.y=y1; y.z=z1;
  dLine(CS,x,y);

  return;
}
/*--------------------------------------------------------------------------------------
dLine: draw line from x0 to x1 in coordinate system CS [P,W]

HISTORY:
  v3.0.0									031115kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void dLine(char CS,double x0,double y0,double x1,double y1)
{
  struct dvec x,y;

  x.dim=y.dim=2;
  x.x=x0; x.y=y0; y.x=x1; y.y=y1;
  dLine(CS,x,y);

  return;
}
