#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
sView: set view by defining
       x0:    the center at which the observer looks
       view:  the direction of the observer seen from x0
       right: the direction that points to the right from the observer's perspective

v3.0.0										031122kr
--------------------------------------------------------------------------------------*/
void sView(struct dvec x0,struct dvec view,struct dvec right)
{
  double buf;

  buf=dotprod(view,right)/(norm(view)*norm(right));
  if (buf>0.99999) PSerror("sView","(view) and (right) almost parallel");
  
  sIPlane(x0,right,vecprod(right,view));

  return;
}
/*--------------------------------------------------------------------------------------
sView: set view by defining
       view:  the direction of the observer seen from x0
       right: the direction that points to the right from the observer's perspective

v3.0.0										031122kr
--------------------------------------------------------------------------------------*/
void sView(struct dvec view,struct dvec right)
{
  struct dvec x0;

  x0.dim=3; x0.x=x0.y=x0.z=0;
  sView(x0,view,right);

  return;
}
