#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
sYWorldCoord: set World coordinates in y-direction by requiring that a line in WC from
              wlow to whigh must be from plow to phigh in PC

HISTORY:
  v3.0.0									031115kr
  v2.0										921206kr
--------------------------------------------------------------------------------------*/
void sYWorldCoord(double wlow,double whigh,double plow,double phigh)
{
  if (plow==phigh || wlow==whigh)
    PSerror("sYWorldCoord", "singular scaling in y-direction");

  PWy=(phigh-plow)/(whigh-wlow); Ply=plow; Wly=wlow;

  return;
}
