#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
updateBB: update BoundingBox [device coordinates, pt]; (x,y) point in [PaperCoordinates]

v3.0.0										031206kr
v2.0										920524kr
--------------------------------------------------------------------------------------*/
void updateBB(double x,double y)
{
  double xbuf,ybuf,buf;

  if (clip_on) {
    if (x<clip_xl) x=clip_xl; if (x>clip_xh) x=clip_xh;
    if (y<clip_yl) y=clip_yl; if (y>clip_yh) y=clip_yh;
  }
  
  xbuf=Pa*x+Pc*y+Px; ybuf=Pb*x+Pd*y+Py;
  buf=xbuf-Pthick; Bxll=(Bxll<buf)?Bxll:buf;
  buf=ybuf-Pthick; Byll=(Byll<buf)?Byll:buf;
  buf=xbuf+Pthick; Bxur=(Bxur>buf)?Bxur:buf;
  buf=ybuf+Pthick; Byur=(Byur>buf)?Byur:buf;
  
  return;
}
