/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *BtdErode(image_cc *im, int step, int mode)
{
	int x,y,z,X,Y,Z,i;
	unsigned long j, NB, count;
	char *se, *voxbuf;
	image_cc *outim;
	
	NB = im->dim[0] * im->dim[1] * im->numbytes;
	voxbuf=(char *)malloc(NB);
	for(j=0;j<NB;j++) *(voxbuf+j)=*(im->pix+j); /** just a copy **/
	
	se = GetSphereElement(step,im->res[0],im->res[1],im->res[2]);
	
	for(z=se[2];z<im->dim[2]-se[2];z++)
	  for(y=se[1];y<im->dim[1]-se[1];y++)
	    for(x=se[0];x<im->dim[0]-se[0];x++)
		    if((rPixel(x,y,z,im)+mode+1)%2)
		    { /**if 1 for mode=1, if 0 for mode=0**/
		      count=0;
		      for(Z=-se[2];Z<=se[2];Z++)
		        for(Y=-se[1];Y<=se[1];Y++)
		          for(X=-se[0];X<=se[0];X++)
							{
			          if((rPixel(x+X,y+Y,z+Z,im)+mode)%2 && *(se+3+count/8) & 1<<count%8)
								{
			            if(mode)
				            *(voxbuf+z/8+x*im->numbytes+y*im->dim[0]*im->numbytes) &= ~(1<<z%8);
			            else
				            *(voxbuf+z/8+x*im->numbytes+y*im->dim[0]*im->numbytes) |= 1<<z%8;
			          }
			          count++;
		          }
	      }
	//outim = InitBtdImage(im->dim[0]-2*se[0],im->dim[1]-2*se[1],im->dim[2]-2*se[2],im->res[0],im->res[1],im->res[2]);
	outim = InitImage(im->dim[0]-2*se[0],im->dim[1]-2*se[1],im->dim[2]-2*se[2], 0,"btd");
	for(i=0;i<3;i++) outim->res[i]=im->res[i];

	for(z=se[2];z<im->dim[2]-se[2];z++)
	  for(y=se[1];y<im->dim[1]-se[1];y++)
	    for(x=se[0];x<im->dim[0]-se[0];x++)
	 	    wPixel(x-se[0],y-se[1],z-se[2],outim,(*(voxbuf + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes) & 1<<z%8)); /** just a copy **/
	free(voxbuf);
	return outim;
}
