/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"


double BtdVolSurf(image_cc *image, double *vv, double *sv)
{
	int x,y,z;
	double VV,le90,le45, l,sin45;
	unsigned long sv90,sv45;
	unsigned long TotPix;

	TotPix = image->dim[0] * image->dim[1] * image->dim[2];
	sv90 = sv45 = 0; 
	VV = 0;
	le90 = (double) image->dim[0] * image->dim[1] * image->dim[2] * image->res[0]/10; /*in cm*/
	le90 *= 2;
	l= sqrt(image->res[0]* image->res[0]+ image->res[2] * image->res[2])/10;
	le45 = (double) image->dim[2] * image->dim[1] * image->dim[0] * l;
	le45 *= 2;

	for(z=0;z<image->dim[2];z++)
	   for(y=0;y<image->dim[1]-1;y++)
		for(x=0;x<image->dim[0]-1;x++){
			if(rPixel(x,y,z,image)) VV++;
			if(rPixel(x,y,z,image)-rPixel(x+1,y,z,image)!=0) sv90++;
			if(rPixel(x,y,z,image)-rPixel(x,y+1,z,image)!=0) sv90++;
			if(z+1 < image->dim[2]){
			  if(rPixel(x,y,z,image)-rPixel(x+1,y,z+1,image)!=0) sv45++;
			  if(rPixel(x,y,z,image)-rPixel(x,y+1,z+1,image)!=0) sv45++;
			}  
		}
	sin45=image->res[0]/(l*10);
	*sv =(double) 2*(sv90 + sv45*sin45)/(le90+le45*sin45);/*in cm/ccm */
	*vv = VV/TotPix;
	return (double)TotPix*image->res[0]*image->res[1]*image->res[2];
}


