/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 26.1.00
\command{       % COMMAND
double BtdVoldens(long int *h);
}{              % DESCRIPTION
Returnes the volume density of the phase coded by [1]  }

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*h}{Pointer to the array of voxel configurations obtained by BtdQuant()}
\return{volume density [-]}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

double BtdVoldens(long int *h)
{
	int i;
	unsigned long vol,vv;

	vol=vv=0;
	for(i=0;i<256;i++){
	  vol+=h[i]; 
	  if(i&1) vv+=h[i]; 
	}
	if(!vol) return 0;
	else return (double)vv/(double)vol;
}
