/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *CircMask(image_cc *im, int xmid, int ymid, int rad)
{
        int x,y,z, maxgrey;
	image_cc *outim, *inimage;

	if(!strcmp(im->itype,"btd")) maxgrey=1;
   	else if(im->numbytes==1)	maxgrey=255;
   	else 			maxgrey=65535;

   if(im->ndim==3){
	inimage=CopyImage(im);
	for(x=0;x<im->dim[0];x++)
	  for(y=0;y<im->dim[1];y++)
	  for(z=0;z<im->dim[2];z++)
	    if(sqrt((x-xmid)*(x-xmid)+(y-ymid)*(y-ymid))>rad)
	      wPixel(x,y,z,inimage,maxgrey);

	outim = InitImage(2*rad+1,2*rad+1,im->dim[2],0,im->itype);
	for(x=0;x<outim->dim[0];x++)
	  for(y=0;y<outim->dim[1];y++)
	  for(z=0;z<outim->dim[2];z++)
	      wPixel(x,y,z,outim,rPixel(xmid-rad+x,ymid-rad+y,z,inimage));
	DeleteImage(inimage);
   }
    else{
	inimage=CopyImage(im);
	for(x=0;x<im->dim[0];x++)
	  for(y=0;y<im->dim[1];y++)
	    if(sqrt((x-xmid)*(x-xmid)+(y-ymid)*(y-ymid))>rad)
	      wPixel(x,y,inimage,maxgrey);

	outim = InitImage(2*rad+1,2*rad+1,0,im->itype);
	for(x=0;x<outim->dim[0];x++)
	  for(y=0;y<outim->dim[1];y++)
	      wPixel(x,y,outim,rPixel(xmid-rad+x,ymid-rad+y,inimage));
	DeleteImage(inimage);
    }
	return(outim);
}
