/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 02.10.02
\command{       % COMMAND
void DddDrawCylinder(image\_c *image,  int xmid, int ymid, int rad, int len,  int val);
}{              % DESCRIPTION
Draws a cylinder at center {tt xmid/xmid} with length {\tt len} and radius {\tt rad} and value {\tt val}. 

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the 3d binary image}
\argu{ xmid, xmid}{coordinates of cylinder center}
\argu{len}{length of cylinder}
\argu{rad}{radius of cylinder}
\argu{val}{value to be written for the cylinder}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

void DddDrawCylinder(image_cc *image, int xmid, int ymid, int zmid, int rad, int len,  int val)
{
  int x,y,z, xx, yy, zz;

	for(z=zmid;z<zmid+len;z++)
	  for(y=ymid-rad;y<ymid+rad;y++)
	    for(x=xmid-rad;x<xmid+rad;x++){
	      xx=x-xmid; yy= y-ymid;
	      if(sqrt((double)yy*yy+xx*xx)<=rad*1.01)
	      wPixel(x,y,z,image,val);
	    }
}

