/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

void StretchRGBBright(image_cc *in, int Low, int High)
{
	int x,y,i;
	int val,bright;
	unsigned char col[3];
	double fac, dval;
	
	for (x=0;x<in->dim[0];x++)
		for (y=0;y<in->dim[1];y++){
		   val=0;
		   for(i=0;i<3;i++)
		   	val+=col[i]=*(in->pix+in->numchannel*(x+y*in->dim[0])+i);
		   bright=val;
		   if(val<Low) val=Low;
		   else if(val>High) val=High;
		   val=(val-Low)*765/(High-Low);

		   if(bright){ 
		      for(i=0;i<3;i++){
			fac=(double)val/bright;
		      	if((dval=col[i]*fac) <= 255)
		   	     *(in->pix+in->numchannel*(x+y*in->dim[0])+i)= (int)dval;
//		   	     *(in->pix+in->numchannel*(x+y*in->dim[0])+i)*=(double)val/bright;
			else     
			     *(in->pix+in->numchannel*(x+y*in->dim[0])+i)=255;
		      }     
	    	   }
		}
}
