/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 13.08.01
\command{       % COMMAND
int bConCom2(image\_c *image,int xv,int yv);
}{              % DESCRIPTION
Determines the size of the  connected object indicated by greylevel 0 around point xv/yv. Return value is the number of pixels attributed to the object. The original image is not changed.

	considering 8-connectivity}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the binary image}
\argu{xv, yv}{coordinates for seed point of the connected component}
\return{number of pixels attributed to the object considering 8-connectivity}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

int bConCom2(image_cc *image,int xv,int yv)
{
	int x,y,b,i,j,count, sum, val=1;
	image_cc *wnd1;
	
	wnd1 = InitImage(image->dim[0],image->dim[1],255);

	wPixel(xv,yv,wnd1,val);
	sum=1;
	
	count=1;
	while(count){
	     count=0;
	     for(y=1;y<wnd1->dim[1]-1;y++)
	      for (x=1;x<wnd1->dim[0]-1;x++){
		     if(rPixel(x,y,wnd1)==val){
			for(j=-1;j<=1;j++)
			for(i=-1;i<=1;i++)
			     if(!rPixel(x+i,y+j,image) && (rPixel(x+i,y+j,wnd1)==255)){
				wPixel(x+i,y+j,wnd1,val);
				sum++;
				count=1;
			     }
		     }
		}
	}
	DeleteImage(wnd1);
	return sum;
}
 
