/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES

%--------------------------------- hj 12.09.03
\command{void bErodeMir(image\_c *image,int step, int mode)}{
as bErode but the outer shell of width {\tt step} is mirrored so that the complete image is treated.

\medskip
\argu{image} {Pointer to the image description structure.}
\argu{step} {radius of the hexagonal structuring element }
\argu{mode} {0 = erosion of the dark phase (0), 1 = dilation} 

}

---------------------------------------------------------------------------*/
#include "quantim4.h"

void bErodeMir(image_cc *im, int step, int mode)
{
	int x,y,X,Y,XX,YY, Xx, Yy,i;
	unsigned long j, count;
	image_cc *outim, *mirim;
	


	mirim=InitImage(im->dim[0]+2*step,im->dim[1]+2*step,0);
	mirim->res[0]=im->res[0];mirim->res[1]=im->res[1];	

	for(y=0;y<mirim->dim[1];y++)
	  for(x=0;x<mirim->dim[0];x++){
	    XX=abs(x-step); YY=abs(y-step);
	    Xx=XX/im->dim[0]; Yy=YY/im->dim[1]; 
	    X=XX-2*(XX-im->dim[0]+1)*Xx; 
	    Y=YY-2*(YY-im->dim[1]+1)*Yy; 
      	    wPixel(x,y,mirim,rPixel(X,Y,im));
	  }
	if(step==9){
	  StoreImage(mirim,"mirim-step9.tiff");
	}
	
	bErode(mirim,step,mode);
	
	outim = InitImage(im->dim[0],im->dim[1],0);
	outim->res[0]=im->res[0]; outim->res[1]=im->res[1];	
	for(y=0;y<im->dim[1];y++)
	    for(x=0;x<im->dim[0];x++)
	 	    wPixel(x,y,im,rPixel(x+step,y+step,mirim)); 

}
