/*
g++ -g -o _classtest classtest.c  UliAddon.c -L /home/weller/local/lib -lm -ltiff -lQuantim4 -lPSgraf3 -I /home/weller/local/include

_classtest image >image.txt
*/

#include <quantim4.h>

void g2MinMax(image_cc *im, double size, int mode);
void g3MinMax(image_cc *im, double size, int mode);
void gMinMax(image_cc *im, double size, int mode);
void gluul(image_cc *im, double size);
void gullu(image_cc *im, double size);

int main(int argc, char **argv)
{
	image_cc *im, *im2, *theDiff;
	int x,y,z;
	im=LoadImage(argv[1]);
	im2=CopyImage(im);
	gluul(im, 3*im->res[0]);
	theDiff=Diff(im, im2);
	gluul(theDiff, 3*theDiff->res[0]);
	for(x=0;x<im->dim[0];x++){
			for(y=0;y<im->dim[1];y++){
				for(z=0;z<im->dim[2];z++){
					printf("%d\t%d\n", rPixel(x,y,z,im), rPixel(x,y,z,theDiff);
				}
			}
	}
}