/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 10.08.01
\command{       % COMMAND
long *gConfunc(image\_c *image);
}{              % DESCRIPTION
Returns the connectivity function of a 2D grey image as a vector of 255 elements corresponding to the Euler number for 255 threshold values. The Euler numbers are not related to the image size. 
}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the grey image}
\return{array of 255 Euler numbers}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

long *gConfunc(image_cc *inim)
{
  int g;
  long *epc;
  image_cc *binim;

  epc=(long *)malloc(256*sizeof(long));
  epc[255]=0;

  for(g=0;g<255;g++){
    binim=CopyImage(inim);
    gBin(g,0,255,binim);
    epc[g]=long(b2DEuler(binim));
    DeleteImage(binim);
  }
  return epc;
}
