/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

void gErode(image_cc *image,int step, int mode) 
{
	int x,y,count,i,j;
	unsigned char Pixel; 
	image_cc *imbuf; 
	
	SetFrame(image,255);
	imbuf=CopyImage(image);
	for(j=0;j<step;j++){
	printf("erosion step %d\n",j);
	   for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			    count=rPixel(x,y,image);
			    if(!mode){
				if(!(j%2)){
				/* if(j%2)*/
				    for(i=0;i<4;i++)
					if((Pixel=rPixel(x+neigh4x[i],y+neigh4y[i],image))< count)
						count=Pixel;
				}
				else
				    for(i=0;i<8;i++)
					if((Pixel=rPixel(x+neigh8x[i],y+neigh8y[i],image))< count)
						count=Pixel;
			    }
			    else{
				if(!(j%2)){
				/* if(j%2)*/
				    for(i=0;i<4;i++)
					if((Pixel=rPixel(x+neigh4x[i],y+neigh4y[i],image))> count)
						count=Pixel;
				}
				else
				    for(i=0;i<8;i++)
					if((Pixel=rPixel(x+neigh8x[i],y+neigh8y[i],image))> count)
						count=Pixel;
			    }
			    wPixel(x,y, imbuf,count);
		}
	for(y=0;y<image->dim[1];y++)
		for (x=0;x<image->dim[0];x++)
			wPixel(x,y,image,rPixel(x,y,imbuf));
	}
	DeleteImage(imbuf);
	return;
}

void gErode_old(image_cc *image,int step, int mode) 
{
	int x,y,count,i,j;
	unsigned char Pixel; 
	image_cc imagebuffer, *imbuf; 
	
	SetFrame(image,255);
	imbuf=&imagebuffer;
	imbuf->pix =(unsigned char *)malloc(image->dim[1]*image->dim[0]);	
	imbuf->dim[0]=image->dim[0];
	imbuf->dim[1]=image->dim[1];
	imbuf->numbytes=image->numbytes;
	for(y=0;y<image->dim[1];y++)
		for (x=0;x<image->dim[0];x++)
			wPixel(x,y,imbuf,rPixel(x,y,image));
	for(j=0;j<step;j++){
	   for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			    count=rPixel(x,y,image);
			    if(!mode){
				if(!(j%2)){
				/* if(j%2)*/
				    for(i=0;i<4;i++)
					if((Pixel=rPixel(x+neigh4x[i],y+neigh4y[i],image))< count)
						count=Pixel;
				}
				else
				    for(i=0;i<8;i++)
					if((Pixel=rPixel(x+neigh8x[i],y+neigh8y[i],image))< count)
						count=Pixel;
			    }
			    else{
				if(!(j%2)){
				/* if(j%2)*/
				    for(i=0;i<4;i++)
					if((Pixel=rPixel(x+neigh4x[i],y+neigh4y[i],image))> count)
						count=Pixel;
				}
				else
				    for(i=0;i<8;i++)
					if((Pixel=rPixel(x+neigh8x[i],y+neigh8y[i],image))> count)
						count=Pixel;
			    }
			    wPixel(x,y, imbuf,count);
		}
	for(y=0;y<image->dim[1];y++)
		for (x=0;x<image->dim[0];x++)
			wPixel(x,y,image,rPixel(x,y,imbuf));
	}
free(imbuf->pix);
}

