/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

double *gHisto(image_cc *im, int precision)
{
	int i,x,y,z;
	unsigned long gval[256],count=0;
	double *gdens;
	
	gdens=(double *)malloc(256*sizeof(double));
	for(i=0;i<256;i++)	gval[i]=0;

	for(y=0;y<im->dim[1];y+=precision)
	for(x=0;x<im->dim[0];x+=precision){
		gval[rPixel(x,y,im)]++;
		count++;
	}
	for(i=0;i<256;i++){
		gdens[i]= (double) gval[i]/count;
	}
	return gdens;
}


