/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

double **dmatrix(int n, int m);
int    **imatrix(int n, int m);
void nextline(FILE *fp);
int nextinput(FILE*fn);
unsigned long CountLines(FILE *fp);


double **dmatrix(int n, int m)
{
  double **dmat;
  int i,j;

  dmat=(double **)malloc(n*sizeof(double *)); 
  for(i=0;i<n;i++)
    dmat[i]=(double *)malloc(m*sizeof(double));   
  return dmat;
}

int **imatrix(int n, int m)
{
  int **mat;
  int i,j;

  mat=(int **)malloc(n*sizeof(int *)); 
  for(i=0;i<n;i++)
    mat[i]=(int *)malloc(m*sizeof(int));   
  return mat;
}

void nextline(FILE *fp)
{
  int c;
  while ((c=fgetc(fp))!=EOF && c!='\n') ;
  return;
}

int nextinput(FILE*fn) /*return 1 when a #-line was passed,2 at EOF, 0 else*/
{
  int c,m=0;

  while ((c=fgetc(fn))!=EOF && (c==' ' || c=='\n')) ;
  while (c!=EOF && c=='#') {
    m=1;
    while ((c=fgetc(fn))!=EOF && c!='\n') ;
    while ((c=fgetc(fn))!=EOF && c==' ') ;
  }
  if (c==EOF) return 2;
  ungetc(c,fn);
  return m;
}

unsigned long CountLines(FILE *fp)
{
  int i=0;
  char c=1;

  while((c=fgetc(fp))!=EOF)
    {
      if(c=='\n') i++;
    }
  fseek(fp,0,SEEK_SET);
  return i;
}
