/*
cd ~/C/PSgraf3/examples
g++ -o _data-function data-function.cpp -lPSgraf3 -lm
_data-function
*/

#include <PSgraf3.h>
#include <math.h>

#define N	200

int main()
{
  int i;
  double x[N],y[N];
  struct dvec X[3],dX[3];

  for (i=0;i<N;i++) {
    x[i]=i*22./(N-1);
    y[i]=10.+x[i]*sin(0.2*pow(x[i],2));
  }


  for (i=0;i<3;i++) {X[i].dim=dX[i].dim=2;}
  X[0].x= 1.5; dX[0].x=1.9; X[0].y=10.2; dX[0].y=0.1;
  X[1].x=11.5; dX[1].x=0.2; X[1].y=20.8; dX[1].y=4.7;
  X[2].x=18.4; dX[2].x=5.4; X[2].y= 4.3; dX[2].y=5.5;

  gPaper("fig/data-function");

    sXWorldCoord(0,22,0,45); sYWorldCoord(0,22,0,25);
    dXAxis(0,0,22,1);        dYAxis(0,0,22,1);

    sStroke(0.2); sDash("[2 1] 0");
    dPolygon('W',x,y,N);

    sThickness(0.15);
    for (i=0;i<3;i++) dDataPoint('W',X[i],dX[i]);
    sThickness(0.1);

    sClipping('W',0,22,0,22);

    sStroke(1); sDash("[] 0");
    dPolygon('W',x,y,N);

    sThickness(0.15);
    for (i=0;i<3;i++) dDataPoint('W',X[i],dX[i]);
  endPS();
  
  return 0;
}
