/*
cd ~/C/PSgraf3/examples
g++ -o _grids grids-test.cpp -lPSgraf3 -lm
_grids
*/
#include <math.h>
#include <PSgraf3.h>
#include <stdio.h>
#include <stdlib.h>

int main()
{
  int Nx=25,Ny=20,Np,Nl,*b,*e,i,j;
  double x[Nx*Ny],y[Nx*Ny],sphi,cphi,dphi=1.5707963/(Nx-1),r,dr=2.5,min,max;
  struct dvec orig;
  FILE *f;
  
  orig.dim=2; orig.x=0; orig.y=0; 

  gPaper("grids");
    sNumber('f',0);
    sXWorldCoord(0,60,0,40);   sYWorldCoord(0,60,50,90);
    dXAxis(orig,60,1);         dYAxis(orig,60,1);
    gRGrid(5,10,6,5,7.1429,8);
    sDash(0); dGrid(1,0); sDash(-1);
    
    sXWorldCoord(0,60,70,110);   sYWorldCoord(0,60,50,90);
    dXAxis(orig,60,1);         dYAxis(orig,60,1);
    sDash(0); dGrid(1,0); sDash(-1);
    deleteGrid();
  endPS();
  
  return 0;
}

