/*
cd ~/C/PSgraf3/examples
g++ -Wall -g -o _text text.cpp -lPSgraf3 -lm
_text
*/

#include <PSgraf3.h>
#include <stdio.h>

int main()
{
  double a,da=360./23;
  char cbuf[127],*s="$\\mathrm{erfc}(x):=\\int_0^x\\mathbb{G}(x)\\,dx$";

  gPaper("fig/text");
    sColorSpace("HSB");
    sText("Helvetica",14,'L','B');
    movea('P',0,0);
    for (a=da;a<360;a+=da) {
      sTextRotation(a); sStroke(0.8*a/360,1,1); dText("Left-Bottom (PS)");
    }
    sTextRotation(0); sStroke(0,1,0); dText("Left-Bottom (PS)");

    sText("TeXfonts",14,'L','B');
    movea('P',55,24);
    for (a=da;a<360;a+=da) {
      sTextRotation(a); sStroke(0.8*a/360,1,1); dText("{\\small\\sf Left-Bottom (\\TeX)}");
    }
    sTextRotation(0); sStroke(0,1,0); dText("{\\Large\\bsf Left-Bottom (\\TeX)}");

    movea('P',40,-30);
    for (a=da;a<360;a+=da) {
      sTextRotation(a); sStroke(0.8*a/360,1,1); dText(s);
    }
    sprintf(cbuf,"{\\LARGE%s}",s);
    sTextRotation(0); sStroke(0,1,0); dText(cbuf);
  endPS();
  
  return 0;
}
