#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dNumber: draw number
         thenumber must be double, to print other types, convert them first

v2.0										940619kr
--------------------------------------------------------------------------------------*/
void dNumber(double thenumber)
{
  int exponent,positive,prec;
  double num,buf;
  char thisformat,cbuf[64];
  
  if (thenumber==0) {
    dText("0");
    return;
  }
  prec=(precision>0)?precision:-precision;
  if (!(positive=thenumber>0)) thenumber=-thenumber;
  buf=log10(thenumber);
  if (nformat=='g')
    thisformat=(fabs(buf)>prec+1)?'e':'f';
  else
    thisformat=nformat;
  if (thisformat=='f') {
    if (positive) sprintf(cbuf,"%1.*f",prec,thenumber);
    else {
      if (TeXfonts==1)
        sprintf(cbuf,"$-%1.*f$",prec,thenumber);
      else
        sprintf(cbuf,"-%1.*f",prec,thenumber);
    }
  } else {
    exponent=(int)buf; if (buf<0) exponent--;
    num=((positive)?1:-1)*thenumber/pow(10,exponent);
    buf=num*pow(10,prec);
    if (pow(10,prec+1)-buf<0.5) {
      exponent++; num/=10;
    }
    if (TeXfonts==1) {
      sprintf(cbuf,"{$%1.*f\\cdot10^{%1i}$}",prec,num,exponent);
    } else {
      sprintf(cbuf,"%1.*fe%+1i",prec,num,exponent);
    }
  }
  dText(cbuf);

  return;
}
