#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dRectangle: draw rectangle {(llx,lly),(urx,ury)} rotated by theta (degrees counter clock
	    wise) with center (llx,lly) in coordinate system CS [P,W]

v3.0.2										041028kr
--------------------------------------------------------------------------------------*/
void dRectangle(char CS,double llx,double lly,double urx,double ury,double theta)
{
  double x[5],y[5],dx=urx-llx,dy=ury-lly,
  	 ct=cos(theta*Deg_to_Rad),st=sin(theta*Deg_to_Rad);
  
  fprintf(PSout,"%%--dRectangle (%c)-->",CS);
  x[0]=x[4]=llx;  y[0]=y[4]=lly;
  x[1]=x[0]+ct*dx; y[1]=y[0]+st*dx;
  x[2]=x[1]-st*dy; y[2]=y[1]+ct*dy;
  x[3]=x[4]-st*dy; y[3]=y[4]+ct*dy;
  dPolygon(CS,x,y,5);
  
  return;
}
/*--------------------------------------------------------------------------------------
dRectangle: draw rectangle {(llx,lly),(urx,ury)} in coordinate system CS [P,W]

v3.0.2										041028kr
--------------------------------------------------------------------------------------*/
void dRectangle(char CS,double llx,double lly,double urx,double ury)
{
  dRectangle(CS,llx,lly,urx,ury,0);
  
  return;
}
