#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
iTCover: inquire coverage of triangular grid; grid must already be covered

         calling function must only supply appropriate pointers, memory is allocated
	 by iTCover

created										001223kr
--------------------------------------------------------------------------------------*/
void iTCover(int NT,int**nodes,double*cgx,double*cgy)
{
  int iT,i;

  if (L_==NULL) PSerror("iTCover","Grid not yet defined");
  if (GT_!=1)   PSerror("iTCover","Grid must be triangular");
  if (T_==NULL) PSerror("iTCover","Grid not yet covered (use gTCover)");
  if (NT!=NT_)  PSerror("iTCover","inconsistent dimensions");

  for (iT=0;iT<NT_;iT++) {
    for (i=0;i<3;i++) nodes[iT][i]=T_[iT].n[i];
    cgx[iT]=T_[iT].cg[0]; cgy[iT]=T_[iT].cg[1];
  }

  return;
}
#undef COM_SYM_DEF
