#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
sXWorldCoord: set World coordinates in x-direction by requiring that a line in WC from
              wlow to whigh must be from plow to phigh in PC

HISTORY:
  v3.0.0									031115kr
  v2.0										921206kr
--------------------------------------------------------------------------------------*/
void sXWorldCoord(double wlow,double whigh,double plow,double phigh)
{
  if (plow==phigh || wlow==whigh)
    PSerror("sXWorldCoord", "singular scaling in y-direction");

  PWx=(phigh-plow)/(whigh-wlow); Plx=plow; Wlx=wlow;

  return;
}
