#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
sZWorldCoord: set World coordinates in z-direction (out of drawing plane) by requiring
              that a line in WC from wlow to whigh must be from phigh to plow in PC
v3.0.0										031115kr
--------------------------------------------------------------------------------------*/
void sZWorldCoord(double wlow,double whigh,double plow,double phigh)
{
  if (wlow==whigh || plow==phigh)
    PSerror("sZWorldCoord", "singular scaling in z-direction");

  PWz=(phigh-plow)/(whigh-wlow); Plz=plow; Wlz=wlow;

  z_set=1;

  return;
}
/*--------------------------------------------------------------------------------------
sZWorldCoord: reset World coordinates in z-direction
v3.0.0										031115kr
--------------------------------------------------------------------------------------*/
void sZWorldCoord()
{
  sZWorldCoord(0,1,0,1);
  z_set=0;

  return;
}
