/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 13.08.01
\command{       % COMMAND
image\_c *Btd2Ddd(image\_c *image);
}{              % DESCRIPTION
Transformation of BTD to DDD format}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the btd-image}
\return{Pointer to the transformed image}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *Btd2Ddd(image_cc *image)
{
        int x,y,z;
	unsigned long j;
	image_cc *copy;

	copy=InitImage(image->dim[0],image->dim[1],image->dim[2],0,"ddd");
	copy->res[0] = image->res[0];
	copy->res[1] = image->res[1];
	copy->res[2] =image->res[2]; 

	for(z=0;z<copy->dim[2];z++)
	for(y=0;y<copy->dim[1];y++)
	for(x=0;x<copy->dim[0];x++)
	  wPixel(x,y,z,copy, rPixel(x,y,z,image)*255);

	return copy;
}

