/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 02.10.02
\command{       % COMMAND
void BtdDrawSphere(image\_c *image,  int xmid, int ymid, int zmid, int rad,  int val);
}{              % DESCRIPTION
Draws a sphere at center {\tt xmid/xmid/zmid} with radius {\tt rad} and value 0 if {\tt val}$=$ 0 and 1 else. 

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the 3d binary image}
\argu{ xmid, xmid, zmid}{coordinates of sphere center}
\argu{rad}{radius of sphere}
\argu{val}{value to be written for the sphere}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

void BtdDrawSphere(image_cc *image, int xmid, int ymid, int zmid, int rad,  int val)
{
  int x,y,z, xx, yy, zz;

  if(val) val=1;
	for(z=zmid-rad;z<zmid+rad;z++)
	  for(y=ymid-rad;y<ymid+rad;y++)
	    for(x=xmid-rad;x<xmid+rad;x++){
	      xx=x-xmid; yy= y-ymid; zz=z-zmid;
	      if(sqrt((double)zz*zz+yy*yy+xx*xx)<=rad*1.01)
	      wPixel(x,y,z,image,val);
	    }
}

