/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

int NTab6[256] ={0,1,1,0,1,0,2,-1,1,2,0,-1,0,-1,-1,0,1,0,2,-1,2,
-1,3,-2,2,1,1,-2,1,-2,0,-1,1,2,0,-1,2,1,1,-2,2,
3,-1,-2,1,0,-2,-1,0,-1,-1,0,1,-2,0,-1,1,0,-2,-1,0,
-3,-3,0,1,2,2,1,0,-1,1,-2,2,3,1,0,-1,-2,-2,-1,0,
-1,1,-2,-1,0,0,-1,1,0,0,-3,-2,-1,-3,0,2,3,1,0,1,
0,0,-3,3,4,0,-1,0,-1,-3,-2,-1,-2,-2,-1,-2,-1,-3,0,0,
-1,-3,-2,-3,-2,-6,1,1,2,2,1,2,1,3,0,0,1,-1,-2,-1,
-2,-2,-1,2,1,3,0,3,0,4,-1,1,0,0,-3,0,-3,-1,-2,0,
1,-1,-2,1,0,0,-3,-1,0,0,-1,-2,-3,-1,0,-1,-2,-2,-1,0,
-3,-1,-2,-2,-3,-1,0,-3,-6,-2,1,0,1,1,0,-1,-2,0,-3,-1,
0,-2,-3,0,-1,-1,0,-1,-2,0,-3,-2,-1,-1,-2,-2,-3,-3,-6,-1,
0,-2,1,-1,0,-2,-3,-2,-3,-3,-6,-2,-1,-1,-2,-1,-2,0,1,0,
-1,-1,0,-1,0,-2,1,-1,-2,0,1,0,1,1,0};

int NTab26[256] ={0,1,1,0,1,0,-2,-1,1,-2,0,-1,0,-1,-1,0,1,0,-2,-1,-2, 
		-1,-1,-2,-6,-3,-3,-2,-3,-2,0,-1,1,-2,0,-1,-6,-3,-3,-2,-2, 
		-1,-1,-2,-3,0,-2,-1,0,-1,-1,0,-3,-2,0,-1,-3,0,-2,-1,0, 
		1,1,0,1,-2,-6,-3,0,-1,-3,-2,-2,-1,-3,0,-1,-2,-2,-1,0, 
		-1,-3,-2,-1,0,0,-1,-3,0,0,1,-2,-1,1,0,-2,-1,-3,0,-3, 
		0,0,1,-1,4,0,3,0,3,1,2,-1,-2,-2,-1,-2,-1,1,0,0, 
		3,1,2,1,2,2,1,1,-6,-2,-3,-2,-3,-1,0,0,-3,-1,-2,-1, 
		-2,-2,-1,-2,-3,-1,0,-1,0,4,3,-3,0,0,1,0,1,3,2,0, 
		-3,-1,-2,-3,0,0,1,-1,0,0,-1,-2,1,-1,0,-1,-2,-2,-1,0, 
		1,3,2,-2,1,-1,0,1,2,2,1,0,-3,-3,0,-1,-2,0,1,-1, 
		0,-2,1,0,-1,-1,0,-1,-2,0,1,-2,-1,3,2,-2,1,1,2,-1, 
		0,2,1,-1,0,-2,1,-2,1,1,2,-2,3,-1,2,-1,2,0,1,0, 
		-1,-1,0,-1,0,2,1,-1,2,0,1,0,1,1,0}; 

int btdNneigh(int z, int *templ, unsigned long **p);


     /*
mode=0 6-connectivity 1 else
deadends != 0 they are preserved, minimum skeleton else
      */
void BtdSkelet(image_cc *in, int mode, int deadends)
{
	int i,j,x,y,z,p,m,r,k,N[2],index,iter;
	int ne,templ,b,offset;
	unsigned long px[3][3], val, flag;
	unsigned char bytes[3];
	image_cc *imbuf;
	unsigned long **pa;

	pa=(unsigned long **)malloc(3*sizeof(unsigned long *));
	for(i=0;i<3;i++) pa[i]=(unsigned long *)malloc(3*sizeof(unsigned long));

	SetBtdShell(in,1,1,1,1);
	imbuf=CopyImage(in);

	iter=0;flag=1;
    while(flag){
	iter++;
        printf("iteration %d:   %ld voxels removed\n",iter-1,flag);
	flag=0;
	for(x=1; x<in->dim[0]-1; x++)
	 for(y=1; y<in->dim[1]-1; y++)
	  for(z=1;z<in->dim[2]-1;z++){
	         for(i=-1;i<2;i++)
	   	  for(j=-1;j<2;j++){		/*3x3 Matrix nach px*/       
		        offset=z/8-(z>7)+(x+j)*imbuf->numbytes+(y+i)*imbuf->dim[0]*imbuf->numbytes;
			px[j+1][i+1]=(unsigned long)*(imbuf->pix+offset);
			px[j+1][i+1]+=(unsigned long)*(imbuf->pix+offset+1)<<8;
			if(z/8<imbuf->numbytes-1)
			  px[j+1][i+1]+=(unsigned long)*(imbuf->pix+offset+2)<<16;

			pa[j+1][i+1]=(unsigned long)*(in->pix+offset);
			pa[j+1][i+1]+=(unsigned long)*(in->pix+offset+1)<<8;
			if(z/8<imbuf->numbytes-1)
			  pa[j+1][i+1]+=(unsigned long)*(in->pix+offset+2)<<16;		  
		  }
		  if( pa[1][1] & 1<<z%8+8*(z>7)){
		     templ=0;
		     ne=btdNneigh(z,&templ,pa);
		     if(z==1 || z==in->dim[2]-2)
		     	if((~templ & 60) == 60)
				ne=6;
		     if(ne<6 && (deadends? ne>2 :1)) /*wenn der Voxel am Rand sitzt */
		     {		  
		   	 N[0]=N[1]=0;
		  	 for(p=0;p<2;p++){		/*einmal mit einmal ohne xyz-Voxel*/
			    for(m=0;m<8;m++){	/*Addition der 8 2x2x2 Wrfel*/
			  	index=0; k=0; r=(m%4)/2;
		     	  	for(i=0;i<2;i++)
	   	  	    	  for(j=0;j<2;j++){	/*Bitmuster der 2x2x2 W�fel nach 'index'*/
			    		if(px[j+m%2][i+m/4]&1<<z%8+8*(z>7)-1+r)
						index += 1<<k;
					if(px[j+m%2][i+m/4]&1<<z%8+8*(z>7)+r)
						index += 1<<k+4;
					k++;
			    	  }
				if(!mode) N[p]+=NTab6[index]; 		
				else      N[p]+=NTab26[index]; 
			    }
			    if(!p)  px[1][1] -= 1<<z%8+8*(z>7);
		   	}
			 if(N[0]==N[1])  flag++;
		   	else           px[1][1]+= 1<<z%8+8*(z>7);             
		      }
		   }						/* all z*/
       	       bytes[0]=px[1][1]; bytes[1]=px[1][1]>>8;  bytes[2]=px[1][1]>>16;
	       offset=z/8-(z>7)+x*imbuf->numbytes+y*imbuf->dim[0]*imbuf->numbytes;
	       *(imbuf->pix+offset)=bytes[0];
	       *(imbuf->pix+offset+1)=bytes[1];
	       if(z/8<imbuf->numbytes-1)
		 *(imbuf->pix+offset+2)=bytes[2];
	  }
	for(j=0;j<in->numbytes*in->dim[1]*in->dim[0];j++) 
		*(in->pix+j) = *(imbuf->pix+j);
   }

}

int btdNneigh(int z, int *templ, unsigned long **p)
{
	int m, N=0;		
		
	for(m=0;m<6;m++)
		if(p[1-(m==2)+(m==3)][1-(m==5)+(m==4)]&1<<z%8+8*(z>7)-(m==0)+(m==1))
		{
			*templ |= 1<<m;
			N++;
		}
return N;
}
