/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *CreateDDDImage(char *buf, int z1, int z2,double rx,double ry,double rz)
{
	int x,y,j,N;
	FILE *fp;
	image_cc *im, *out;
	char buffer[127];
	
	out =(image_cc *)malloc(sizeof(image_cc));
	N=z2-z1+1;

	sprintf( buffer,"%s%05d.tiff",buf,z1);
	im=LoadImage(buffer);
	if(im->numbytes==1)
		out=InitImage(im->dim[0],im->dim[1],N,0,"ddd");
	else
		out=InitImage(im->dim[0],im->dim[1],N,0,"ddd16");
	out->res[0] = rx;
	out->res[1] = ry;
	out->res[2] = rz;
	
	for(j=0;j<N;j++){
		if(j){
		   sprintf( buffer,"%s%05d.tiff",buf,z1+j);
		   im=LoadImage(buffer);
		}
		if(im->dim[1]!=out->dim[1] || im->dim[0]!=out->dim[0])
		   {printf("\n%s:\ncannot handle images of different size!!\n", buffer); exit(0);}
		for (y=0;y<im->dim[1];y++)
		    for (x=0;x<im->dim[0];x++)
			wPixel(x,y,j, out, rPixel(x,y, im));
		DeleteImage(im);
	}
return out;	
}
