/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

void DddMinMax(image_cc *im,int mode)
/* minimum of 26-neighbors mode= 0, else maximum */ 
{
	int x,y,z,j;
	unsigned char v,vmin, *pixbuf;
	
	pixbuf=(unsigned char *)malloc(im->dim[0]*im->dim[1]*im->dim[2]);
	
	for(z=1;z<im->dim[2]-1;z++)
	 for(x=1;x<im->dim[0]-1;x++)
	  for(y=1;y<im->dim[1]-1;y++){
	  	vmin=rPixel(x,y,z,im);
	  	for(j=0;j<26;j++){
		  if(mode){
		    if((v=rPixel(x+N26x[j],y+N26y[j],z+N26z[j],im))>vmin)
		   	vmin=v;
		  }	
		  else{	
		    if((v=rPixel(x+N26x[j],y+N26y[j],z+N26z[j],im))<vmin)
		   	vmin=v;
		  }	
		}
		*(pixbuf+ x + y*im->dim[0] + z*im->dim[0]*im->dim[1])=vmin;
	  }
	free(im->pix);  
	im->pix=pixbuf;
}
