/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 13.08.01
\command{       % COMMAND
double *GetGreyCdf(image\_c *im)
}{              % DESCRIPTION
Returnes a 255 element array containing the cdf of grey levels}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*im}{Pointer to the 2D grey image}
\return{cdf array (255 elements)}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

double *GetGreyCdf(image_cc *im)
{
	int i;
	double *cdf, *histo;
	double sum;
	
	cdf = (double *)malloc(256*sizeof(double));
	
	histo = gHisto(im,1);
	sum=histo[0];
	for(i=1;i<256;i++){
		sum+=histo[i];
		histo[i]+=histo[i-1];
	}
	for(i=0;i<256;i++)
		cdf[i]= histo[i]/sum;		
return cdf;
}
