/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 13.08.01
\command{       % COMMAND
void MinMaxf(double *ar, int n, double *min, double *max);
}{              % DESCRIPTION
calculates the minimum and maximum value of a double array}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*ar}{Pointer to the array}
\argu{n}{dimension of the array}
\argu{*min}{addresse to store minimum}
\argu{*max}{addresse to store maximum}
\return{Euler number [1/L$^3$]  in units of image->res[0]}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

void MinMaxf(double *ar, int n, double *min, double *max)
{
  int i;
  
  *min = *max = ar[0];
  for(i=0;i<n;i++)
    if(ar[i]>*max) *max=ar[i];
  else if (ar[i]<*min) *min=ar[i];
}

