#include "tiffio.h"
#include "quantim4.h"



void SaveShiftImage(image_cc *image, char *buf,int maxx, int maxy,int vx, int vy)
{
	long row;
	TIFF *tif;

	tif = TIFFOpen(buf, "w");
	TIFFSetField(tif, TIFFTAG_IMAGELENGTH, image->dim[1]-maxy);
	TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISBLACK);
	TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, image->dim[0]-maxx);
	TIFFSetField(tif, TIFFTAG_COMPRESSION, COMPRESSION_NONE);
	TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
	TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, image->dim[2]);
	TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, image->numbytes);
	for (row =0-vy; row < image->dim[1]-maxy-vy; row++)
TIFFWriteScanline(tif, image->pix-(vx*image->numbytes)+(row*image->dim[0]*image->numbytes), row+vy,2);

TIFFClose(tif); 
}
