/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 04.06.03
\command{       % COMMAND
void SetDddShell(image\_c *im, int thick, int val);
}{              % DESCRIPTION
Writes the complete shell of thickness {\tt thick}  to {\tt val}   

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{thick}{Thickness of the shell}
\argu{val}{Value written to the shell}
\return{no return value}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

void SetDddShell(image_cc *im, int thick, int val)
     /** write the complete shell of thicjness {\tt thick}  to {\tt val}   **/
{
	int x,y,z;
	
	for(z=0;z<thick;z++)
	for(y=0;y<im->dim[1];y++) for(x=0;x<im->dim[0];x++)
	    wPixel(x,y,z,im,val);
   
	for(z=im->dim[2]-1;z>im->dim[2]-1-thick;z--)
	for(y=0;y<im->dim[1];y++) for(x=0;x<im->dim[0];x++)
	    wPixel(x,y,z,im,val);

	for(y=0;y<thick;y++)
	for(z=0;z<im->dim[2];z++) for(x=0;x<im->dim[0];x++)
	    wPixel(x,y,z,im,val);

	for(y=im->dim[1]-1;y>im->dim[1]-1-thick;y--)
	for(z=0;z<im->dim[2];z++) for(x=0;x<im->dim[0];x++) 
	    wPixel(x,y,z,im,val);

	for(x=0;x<thick;x++)
	for(z=0;z<im->dim[2];z++) for(y=0;y<im->dim[1];y++) 
	    wPixel(x,y,z,im,val);

	for(x=im->dim[0]-1;x>im->dim[0]-1-thick;x--)
	for(z=0;z<im->dim[2];z++) for(y=0;y<im->dim[1];y++)
	    wPixel(x,y,z,im,val);  
}
