/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES

%--------------------------------- hj 11.06.02
\command{       % COMMAND
double bVoldens(image\_c *image, long int *h);
}{              % DESCRIPTION
Returnes the Area density of a 2D binary structure (0 phase) which corresponds to the Volume density of a 3D structure as estimated from the 2-dimensional section}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*h}{Pointer to the array of pixel configurations obtained by bQuant()}
\return{Volume density [-] }
}

 
---------------------------------------------------------------------------*/
#include "quantim4.h"

double bVoldens(image_cc *image, long int *h)
{
	unsigned int i,p;
	long int iChi=0, iVol=0;
 
 	for(i=0;i<16;i++){
		iChi+=(i&1)*h[i];
		iVol+=h[i];
	}
	if(!iVol) return 0;
 	else return (double)iChi/iVol;
}

 
 
