/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 12.06.02
\command{       % COMMAND
void HistoMatch(double *cdf, image\_c *image)
}{              % DESCRIPTION
Transforms the histogram of an image according to a predefined cdf

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*cdf}{predefined cdf of grey levels}
\argu{*image}{Pointer to the 2D grey scale image }
\return{no return value}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

void gHistoMatch(double *cdf, image_cc *image)
{
  int x,y,i,val;
  double *iscdf;

  iscdf = GetGreyCdf(image);
  
  for(y=0;y<image->dim[1];y++)
    for(x=0;x<image->dim[0];x++){
	  val =rPixel(x,y,image);
	  for(i=0;i<256;i++)
	      if(iscdf[val]<cdf[i]) 
		  break;
          val = i>255?255:i;  
	  wPixel(x,y,image,val);
    }
} 
